//
//  MainController.m
//  FavIconTest
//
//  Created by Andreas on 11.09.04.
//  Copyright 2004 Andreas Mayer. All rights reserved.
//

#import "MainController.h"
#import "NSString_AMAdditions.h"
#import "AMURLLoader.h"


@implementation MainController

- (AMURLLoader *)loader
{
	return loader;
}

- (void)setLoader:(AMURLLoader *)value
{
	if (loader != value) {
		[loader release];
		loader = [value retain];
	}
}


- (IBAction)getFavIcon:(id)sender
{
	[favIconView setImage:nil];
	[errorMessage setHidden:YES];
	NSString *path = [[baseURL stringValue] stringWithFirstURLComponent];
	NSURL *url = [NSURL URLWithString:path];
	url = [[[NSURL alloc] initWithString:@"favicon.ico" relativeToURL:url] autorelease];
	[self setLoader:[AMURLLoader loaderWithURL:url target:self selector:@selector(didReceiveData:context:) userInfo:nil]];
	[progressIndicator startAnimation:self];
	[[self loader] load];
}

- (void)didReceiveData:(NSData *)data context:(NSDictionary *)context
{
	[progressIndicator stopAnimation:self];
	if (data) {
		int  statusCode = 0;
		NSURLResponse *response = [context objectForKey:@"response"];
		if ([response isKindOfClass:[NSHTTPURLResponse class]]) {
			statusCode = [(NSHTTPURLResponse *)response statusCode];
			[errorMessage setStringValue:[NSString stringWithFormat:@"Status: %i", statusCode]];
			[errorMessage setHidden:NO];
		}
		if (statusCode < 400) {
			NSImage *image = [[[NSImage alloc] initWithData:data] autorelease];
			[favIconView setImage:image];
		}
	} else {
		[errorMessage setStringValue:[(NSError *)[context objectForKey:@"error"] localizedDescription]];
		[errorMessage setHidden:NO];
	}
}


@end
